<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Lexicon</TITLE>
<link href="suif1_103.html" rel=Next>
<link href="suif1_101.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_101.html">previous</A>, <A HREF="suif1_103.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC102" HREF="suif1_toc.html#TOC102">Lexicon</A></H2>
<P>
<A NAME="IDX723"></A>
<A NAME="IDX724"></A>

</P>
<P>
<A NAME="IDX725"></A>
<A NAME="IDX726"></A>
Almost all character strings in SUIF are entered in a hash table called
the <CODE>lexicon</CODE>.  This table removes duplicate strings so that string
comparisons can be reduced to simple pointer comparisons.  The
<CODE>lexicon</CODE> is an object of the <CODE>string_table</CODE> class defined in
the <TT>`stringtable.h'</TT> and <TT>`stringtable.cc'</TT> files.

</P>
<P>
<A NAME="IDX727"></A>
<A NAME="IDX728"></A>
A <CODE>string_table</CODE> is an open hash table; each bucket is a linked
list of string entries represented by objects of the <CODE>string_e</CODE>
class.  The only public method in the <CODE>string_table</CODE> class is
called <CODE>enter</CODE>.  This method searches the table for a specified
string.  If the string is found, <CODE>enter</CODE> returns a pointer to the
existing <CODE>string_e</CODE> entry.  Otherwise, it creates a new entry and
adds it to the table.  In either case, the actual character string
pointer can be retrieved directly from the <CODE>sp</CODE> field of the
resulting <CODE>string_e</CODE> entry.

</P>
<P>
None of the strings in the <CODE>lexicon</CODE> are deallocated until a SUIF
program terminates.  Consequently, when adding a new string to the
table, it is copied to the heap in case the original string is stored on
the stack.  If the string is known to be allocated on the heap and will
never be modified or deallocated, this string copy can be avoided by
setting the optional <CODE>fixed</CODE> flag when calling <CODE>enter</CODE>.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_101.html">previous</A>, <A HREF="suif1_103.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
